<?php
if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly
/**
 * pdf_headercontent.php
 * 
 * This file contains header functions
 * 
 */
if (! class_exists ( 'TCPDF' )) {
	require_once MWBPDF_GEN_PATH . '/tcpdf/tcpdf.php';
}
if( !isset($this->options['2']['page_header']) || ($this->options['2']['page_header']=="None" )) {
	define('PRINT_HEADER','1');
}
class CUSTOMPDF extends TCPDF {
	/**
	 * General header settings
	 * @name header
	 * @author makewebbetter<webmaster@makewebbetter.com>
	 * @link http://makewebbetter.com 
	 */
	public function header() {
		if(defined('PRINT_HEADER')) {
			$this->setPrintHeader ( false );
		} else {
			parent::header();
		}
	}

	/**
	 * General Footer settings
	 * @name Footer
	 * @author makewebbetter<webmaster@makewebbetter.com>
	 * @link http://makewebbetter.com 
	 */
	public function Footer() {
		$options = get_option ( MWBPDF_GEN_PREFIX );
		
		if(isset($options['7']['custom_footer_option'])) {
			if(!empty($options['7']['custom_footer'])){


			//writeHTMLCell($w, $h, $x, $y, $html='', $border=0, $ln=0, $fill=0, $reseth=true, $align='', $autopadding=true)
			$this->writeHTMLCell ($options[7]['footer_cell_width'], $options['7']['footer_min_height'], $options[7]['footer_lcornerX'], $options['7']['footer_font_lcornerY'], $options['7']['custom_footer'], '','', $options['7']['footer_cell_fill'], true, $options['7']['footer_align'], $options['7']['footer_cell_auto_padding']);
			}
				
		} else {
			// call parent footer method for default footer
			parent::Footer();
		}
		
	}
}